//#parameter Iterations 8 16 1
//#parameter Power 8 16 2

float DistanceEstimation(float3 a_Position, __constant float* a_Parameters)
{
	float3 z = a_Position;
	float dr = 1.0;
	float r = length(z);

	float theta = acos(z.z / r);
	float phi = atan2(z.y, z.x);

	for (float i = 0; i < a_Parameters[0]; i += 1.0f)
	{
		r = length(z);

		if (r > 2.0f)
		{
			break;
		}
		
		// convert to polar coordinates
		theta = acos(z.z / r);
		phi = atan2(z.y, z.x);
		dr = pow(r, a_Parameters[1] - 1.0) * a_Parameters[1] * dr + 1.0;//was param[0]
		
		// scale and rotate the point
		float zr = pow(r, a_Parameters[1]);
		theta = theta * a_Parameters[1];
		phi = phi * a_Parameters[1];
		
		// convert back to cartesian coordinates
		z.x = zr * (sin(theta) * cos(phi));
		z.y = zr * (sin(phi) * sin(theta));
		z.z = zr * (cos(theta));
		
		z += a_Position;
	}
	r = length(z);//one last radius calc is needed

	return min(1.0f, 0.5 * log(r) * r / dr);
}